QGIS Application - Bug report #4087

Split Features tool: lines are split also at every self-intersection

2011-07-14 09:15 PM - jcnotter -

Status: Open
Priority: Normal
Assignee:

Category: Digitising

Affected QGIS version:3.7(master)
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 14070

Description

When you use this function to a location, it splits the polyline at each intersections on the polyline and you get a lot of polylines and not 2

as you want

Example : for separating the return track, you get many little tracks ...

Related issues:

Duplicated by QGIS Application - Bug report # 21439: Split Tool: Self-interse... Closed 2019-03-01

History

#1 - 2011-08-29 10:12 PM - Paolo Cavallini
- Pull Request or Patch supplied set to No

See also #4147

#2 - 2011-12-09 08:22 AM - Paolo Cavallini
- Category set to 44

#3 - 2011-12-16 02:11 PM - Giovanni Manghi

- Target version set to Version 1.7.4

#4 - 2011-12-24 06:58 AM - Giovanni Manghi
- Affected QGIS version set to master

- Crashes QGIS or corrupts data set to No

- Subject changed from Split Features to Split Features tool: lines are split also at every self-intersection

- Assignee set to cfarmer -

#5 - 2011-12-25 12:50 AM - Giovanni Manghi

see also #4559

#6 - 2011-12-27 11:52 AM - Richard Duivenvoorde

don't know if cfarmer is the right person to assign this issue to??

the split feature tool is part of

int QgsVectorLayer::splitFeatures( const QList<QgsPoint>& splitLine, bool topologicalEditing )
(implemented via geos, not via ftools (for what | can see))

the actual bug is that the line is also split on it's self intersections

#7 - 2012-04-16 05:56 AM - Giovanni Manghi

- Priority changed from High to Normal

#8 - 2012-04-16 06:28 AM - Paolo Cavallini

- Target version changed from Version 1.7.4 to Version 1.8.0

#9 - 2012-09-04 11:59 AM - Paolo Cavallini
- Target version changed from Version 1.8.0 to Version 2.0.0

#10 - 2013-07-13 03:17 AM - Giovanni Manghi
- Assignee deleted (cfarmer -)

- Status changed from Open to Closed

- Resolution set to worksforme

seems fixed in master, reopen if necessary.

#11 - 2013-07-13 07:58 AM - Richard Duivenvoorde

- Status changed from Closed to Reopened

Still not working for me.

If I open the attached shapefile, containing 1 feature (open feature table to see that).

then set layer in edit modus and then from the 'Advanced digitizing toolbar' use the 'split features' tool.

If you then create a 'cut line' in the middle. | would think that the result would be 2 (two) lines.

But if you open the attribute table, it will show you 15 features. Apperently the line is cut on every place where is intersects itself. To me this looks as not

what you want.

OR (Giovanni), do we have different settings? And do you have a setting which | do not have...

#12 - 2013-07-13 09:07 AM - Giovanni Manghi

- Resolution deleted (worksforme)

#13 - 2014-06-21 03:38 PM - Jiirgen Fischer
- Category changed from 44 to Digitising

#14 - 2014-06-28 07:40 AM - Jiirgen Fischer

- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#15 - 2014-07-19 07:27 AM - Brett Russ

I'm a new QGIS user and thought | was nuts until | found this bug report. | open a single GPX track in QGIS, convert it to a shapefile, and try to split it into
two sections. Before the split feature, the attribute table had 1 entry; after: 75 entries! This is impossible to deal with.

Since this defect is so far down the priority list, is there a workaround we could try in cases where we need to split a self intersecting line? | really don't
want to trace new lines over the original GPX/SHP for every subsection of the original.

Thanks

#16 - 2014-09-12 06:57 PM - Brett Russ

| am setting up Mac OS X 10.9.4 to do QGIS development. | could use a tip or two on where to look to try fixing this issue. Thanks in advance.

#17 - 2015-09-28 04:50 PM - Pedro Venancio

- Target version changed from Future Release - Lower Priority to Version 2.12

- File split.zip added

Hi,

Please make a test with the two layers | am attaching.

The layer trajeto_completo_2.shp has one single line and the layer percurso_pedestre_2.shp has 2 lines.

Try to make a Split feature in each of the layers.

Making split in percurso_pedestre_2.shp, | get 3 lines, as expected.

Making split in trajeto_completo_2.shp, what happens is that the split is done at all points where the lines intersect.

I thought | was with the problem of this ticket, but more strange is that does not always happen, and the layer in this example is the same, it was only made
the split of trajeto_completo_2.shp in another software, resulting in percurso_pedestre_2.shp.

Can anyone see any substantial difference between the two shapefiles that allows explain this different behavior?

| think one way to fix this issue would be through "Enable topological editing" option of the Snapping Options. If this option was active, then it should do the
split at every self-intersection, as a network topologically should not intersect.

However, for example in the case of road viaducts, the lines can cross without intersect, since they are at different levels. So, for these cases, the "Enable
topological editing" option should be deselected.

This approach fails only because there may be the two situations in the same layer, and therefore may not be very worthwhile.

It is best to avoid it to happen, because to make the split at self-intersections will be enough to import the layer into GRASS, that will automatically enforce
topology.

In any case, this issue seems to me to have some priority.

#18 - 2015-11-07 11:25 AM - Giovanni Manghi

- Target version deleted (Version 2.12)

#19 - 2017-05-01 01:10 AM - Giovanni Manghi
- Regression? set to No
- Easy fix? set to No

#20 - 2019-03-02 11:15 AM - Giovanni Manghi
- Duplicated by Bug report #21439: Split Tool: Self-intersecting line is also split at every intersection added

#21 - 2019-03-05 09:42 AM - Thomas Baumann

The saga tool "split lines with lines" works fine to split lines even if they have self intersections. Perhaps one of the devs could have a look at the saga

source code how they manage to split the lines correctly? http://www.saga-gis.org/saga_tool_doc/2.2.7/shapes_lines_6.html

#22 - 2019-03-05 03:26 PM - Giovanni Manghi

- Affected QGIS version changed from master to 3.7(master)

- Description updated

- Status changed from Reopened to Open

#23 - 2019-03-11 05:05 PM - Pedro Venancio

Pedro Venancio wrote:

Hi,

Please make a test with the two layers | am attaching.

The layer trajeto_completo_2.shp has one single line and the layer percurso_pedestre_2.shp has 2 lines.
Try to make a Split feature in each of the layers.

Making split in percurso_pedestre_2.shp, | get 3 lines, as expected.

Making split in trajeto_completo_2.shp, what happens is that the split is done at all points where the lines intersect.

I thought | was with the problem of this ticket, but more strange is that does not always happen, and the layer in this example is the same, it was only

made the split of trajeto_completo_2.shp in another software, resulting in percurso_pedestre_2.shp.

Can anyone see any substantial difference between the two shapefiles that allows explain this different behavior?

| think one way to fix this issue would be through "Enable topological editing" option of the Snapping Options. If this option was active, then it should
do the split at every self-intersection, as a network topologically should not intersect.

However, for example in the case of road viaducts, the lines can cross without intersect, since they are at different levels. So, for these cases, the
"Enable topological editing” option should be deselected.

This approach fails only because there may be the two situations in the same layer, and therefore may not be very worthwhile.

It is best to avoid it to happen, because to make the split at self-intersections will be enough to import the layer into GRASS, that will automatically

enforce topology.

In any case, this issue seems to me to have some priority.

This is still true in QGIS 3.x
http://www.saga-gis.org/saga_tool_doc/2.2.7/shapes_lines_6.html

Files

temp.zip 2.16 KB 2011-07-14 jcnotter -
split.zip 8.82 KB 2015-09-28 Pedro Venancio
